import string
import whrandom

#########################################
## class language (abstract class)

class language:
  "the language class, for multilanguage worlds"

  ## translate a sentence from English to language
  def translate(self, sentence):

    for letter in self.dialect.keys():
       sentence = string.replace(sentence, letter, self.dialect[letter] )

    for letter in self.base.keys():
      sentence = string.replace(sentence, letter, self.base[letter])

    return sentence

  ## Translate a sentence from language to English
  ##   knowledge is a value between [0,1] and gives the translation accuracy 
  ##   (1 means perfect translation)
  def english(self, sentence, knowledge = 1):

    for letter in self.base.keys():
      if whrandom.random()<knowledge:
        sentence = string.replace(sentence, self.base[letter], letter )

    for letter in self.dialect.keys():
           ## it's easier to know the main language features
      if whrandom.random()<knowledge*1.5:  
        sentence = string.replace(sentence, self.dialect[letter], letter )

    return sentence

  def __str__(self):
    return self.name + ' dialect of ' + self.language + ' language'

  def __init__(self, dialect, language):
    self.name     = dialect
    self.language = language
    self.letters  = ['a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z']

    self.base     = {}
    self.dialect  = {}

## end class language
#########################################
  
class orkish(language):
  "The Orkish Language"

  def __init__(self, dialect, newDict={}):
    language.__init__(self, dialect, 'orkish')

    ## base of all orkish languages

    self.base['a'] = 'arsh'
    self.base['e'] = 'errk'
    self.base['i'] = 'insh'
    self.base['o'] = 'orck'
    self.base['u'] = 'urgk'
    self.base['y'] = 'yxxh'

    ## different dialect (this can also be done with more subclassing)

    self.dialect = newDict

#########################################

## Sample

print '*'*40

rhumDict = {}
rhumDict['br'] = 'kr'

L1 = orkish('rhum', rhumDict)

print L1
s = L1.translate('so, did you find there those dammed Hobbits?')
print s
print L1.english(s)

######

urukDict = {}
urukDict['am'] = 'uruk'
urukDict['so'] = 'os'
urukDict['there'] = 'J'

L2 = orkish('uruk', urukDict)

print L2
s = L2.translate('so, did you find there those dammed Hobbits?')
print s
print L2.english(s, 0.750)
