from   types import *
import rotor               # import encrypt tools

################################################
#  Message Class
#
class Message:
   "Message Class"
#
#  Encrypt message using a numeric key
#
   def encrypt(self, numKey):
      rt = rotor.newrotor('key', numKey)
      self.msg = rt.encrypt(self.msg)
      self.isEncrypt  = 1
      return self
#
#  Decrypt message using a numeric key
#
   def decrypt(self, numKey):
      rt = rotor.newrotor('key', numKey)
      self.msg = rt.decrypt(self.msg)
      self.isEncrypt  = 0
      return self
#
#  Print message object
#   
   def __str__(self):
     if type(self.receiverId) is IntType:
        if self.receiverId == 0:
           print '<Broadcast Msg: \'' + self.msg + '\' from obj id: %d>' % (self.senderId)
        else:
           print '<Msg: \'' + self.msg + '\' from obj id: %d to obj id %d>' % (self.senderId, self.receiverId)
     else:
        print '<Group Msg: \'' + self.msg + '\' from obj id: %d to %s>' % (self.senderId, self.receiverId)
#
#  Construct message (default receiver is Universe with Id = 0)
#   
   def __init__(self, msg, senderId, receiverId=0):
      self.msg        = msg
      self.senderId   = senderId
      self.receiverId = receiverId
      self.isEncrypt  = 0
#
#  Message Class
################################################

x = Message('hi',3,[4,6])

print x.encrypt(12)
print x.decrypt(12)
